/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.action;

import java.util.Date;
import net.sourceforge.stripes.action.DefaultHandler;
import net.sourceforge.stripes.action.DontValidate;
import net.sourceforge.stripes.action.ForwardResolution;
import net.sourceforge.stripes.action.Resolution;
import net.sourceforge.stripes.action.SimpleMessage;
import net.sourceforge.stripes.validation.EmailTypeConverter;
import net.sourceforge.stripes.validation.Validate;
import net.sourceforge.stripes.validation.ValidateNestedProperties;
import stripesbook.model.Contact;
import stripesbook.model.Gender;

public class ClientFormActionBean extends BaseActionBean {
    private static final String FORM =
        "/WEB-INF/jsp/client_side_validation.jsp";

    @DefaultHandler
    public Resolution form() {
        return new ForwardResolution(FORM);
    }
    public Resolution save() {
        getContext().getMessages()
            .add(new SimpleMessage("All input is valid."));
        return new ForwardResolution(FORM);
    }
    @DontValidate
    public Resolution cancel() {
        getContext().getMessages()
            .add(new SimpleMessage("Action cancelled."));
        return new ForwardResolution(FORM);
    }
    @ValidateNestedProperties({
        @Validate(field="firstName", maxlength=25),
        @Validate(field="lastName",  minlength=2, maxlength=40),
        @Validate(field="email", required=true, on="save",
            converter=EmailTypeConverter.class),
        @Validate(field="birthDate", expression="${this < today}")
    })
    private Contact contact;
    public Contact getContact() {
        return contact;
    }
    public void setContact(Contact contact) {
        this.contact = contact;
    }
    public Date getToday() {
        return new Date();
    }
    public Gender[] getGenders() {
        return Gender.values();
    }
}
