<!--
 ! Excerpted from "Stripes: and Java Web Development is Fun Again",
 ! published by The Pragmatic Bookshelf.
 ! Copyrights apply to this code. It may not be used to create training material, 
 ! courses, books, articles, and the like. Contact us if you are in doubt.
 ! We make no guarantees that this code is fit for any purpose. 
 ! Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
-->
<%@page contentType="text/html;charset=ISO-8859-1" language="java"%>
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
  "http://www.w3.org/TR/html4/strict.dtd">
<html>
  <head>
    <title>Client-side validation example</title>
    <link rel="stylesheet" type="text/css"
      href="${contextPath}/css/style.css">
    <%-- START:imports --%>
    <script src="${contextPath}/js/jquery.js"
      type="text/javascript"></script>

    <script src="${contextPath}/js/jquery.validation.js"
      type="text/javascript"></script>

    <script src="${contextPath}/js/stripes.jquery.validation.js"
      type="text/javascript"></script>
    <%-- END:imports --%>
  </head>
  <body>
    <h3>Client-side validation example</h3>
    <%-- START:fmd --%>
    <s:form beanclass="stripesbook.action.ClientFormActionBean">
      <!-- form input controls... -->

    <%-- END:fmd --%>
      <table>
        <tr>
          <td><s:label for="contact.email">Email:</s:label></td>
          <td>
            <%-- START:dyn --%>
            <s-dyn:text id="contact.email" name="contact.email"
              autocomplete="off"/>
            <%-- END:dyn --%>
          </td>
          <td><s:errors field="contact.email"/></td>
        </tr>
        <tr>
          <td><s:label for="contact.firstName">First name:</s:label></td>
          <td><s-dyn:text id="contact.firstName" name="contact.firstName" autocomplete="off"/></td>
          <td><s:errors field="contact.firstName"/></td>
        </tr>
        <tr>
          <td><s:label for="contact.lastName">Last name:</s:label></td>
          <td><s-dyn:text id="contact.lastName" name="contact.lastName" autocomplete="off"/></td>
          <td><s:errors field="contact.lastName"/></td>
        </tr>
        <tr>
          <td><s:label for="contact.phoneNumber">Phone number:</s:label></td>
          <td>
            <s-dyn:text id="contact.phoneNumber" name="contact.phoneNumber" formatType="dashes" autocomplete="off"/>
          </td>
          <td><s:errors field="contact.phoneNumber"/></td>
        </tr>
        <tr>
          <td><s:label for="contact.birthDate">Birth date:</s:label></td>
          <td>
            <s-dyn:text id="contact.birthDate" name="contact.birthDate" formatPattern="yyyy-MM-dd" autocomplete="off"/>
          </td>
          <td><s:errors field="contact.birthDate"/></td>
        </tr>
        <tr>
          <td><s:label for="contact.gender">Gender:</s:label></td>
          <td class="field">
            <c:forEach var="gender" items="${actionBean.genders}">
              <s:radio name="contact.gender" value="${gender}" id="${gender}"/>
              <label for="${gender}">${gender}</label>
            </c:forEach>
          </td>
        </tr>
        <tr>
          <td>&nbsp;</td>
          <td>
            <s:submit name="save" value="Save"/>
            <s:submit name="cancel" value="Cancel"/>
          </td>
        </tr>
      </table>
      <%-- START:fmd --%>
      <s:field-metadata var="fmd"/>
      <script type="text/javascript">
      
        
        var options = {
          invalidClass: 'error',
          disableSubmit: false
        };
        applyStripesValidation('${fmd.formId}', ${fmd}, options);
        
      /*
     START:fmd
        applyStripesValidation('${fmd.formId}', ${fmd})
      */
      
      </script>
    </s:form>
    <%-- END:fmd --%>
    <s:messages/>
  </body>
</html>
