<!--
 ! Excerpted from "Stripes: and Java Web Development is Fun Again",
 ! published by The Pragmatic Bookshelf.
 ! Copyrights apply to this code. It may not be used to create training material, 
 ! courses, books, articles, and the like. Contact us if you are in doubt.
 ! We make no guarantees that this code is fit for any purpose. 
 ! Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
-->
<%@page contentType="text/html;charset=ISO-8859-1" language="java"%>
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
  "http://www.w3.org/TR/html4/strict.dtd">
<html>
  <head>
    <title>Server-side validation example</title>
    <link rel="stylesheet" type="text/css"
      href="${contextPath}/css/style.css">
    <script src="${contextPath}/js/jquery.js"
      type="text/javascript"></script>
  </head>
  <body>
    <h3>Server-side validation example</h3>
    <s:form beanclass="stripesbook.action.ServerFormActionBean">
      <table>
        <tr>
          <td><s:label for="contact.email">Email:</s:label></td>
          <td>
          <%-- START:onkeyup --%>
            <s-dyn:text id="contact.email" name="contact.email"
              autocomplete="off" onkeyup="validate(this.form);"/>
          <%-- END:onkeyup --%>
          </td>
          <td>
          <%-- START:span --%>
            <span id="contact_email" class="error">
              <s:errors field="contact.email"/>
            </span>
          <%-- END:span --%>
          </td>
        </tr>
        <tr>
          <td><s:label for="contact.firstName">First name:</s:label></td>
          <td>
            <s-dyn:text name="contact.firstName" autocomplete="off"
              onkeyup="validate(this.form);"/>
          </td>
          <td>
            <span id="contact_firstName" class="error">
              <s:errors field="contact.firstName"/>
            </span>
          </td>
        </tr>
        <tr>
          <td><s:label for="contact.lastName">Last name:</s:label></td>
          <td>
            <s-dyn:text name="contact.lastName" autocomplete="off"
              onkeyup="validate(this.form);"/>
          </td>
          <td>
            <span id="contact_lastName" class="error">
              <s:errors field="contact.lastName"/>
            </span>
          </td>
        </tr>
        <tr>
          <td><s:label for="contact.phoneNumber">Phone number:</s:label></td>
          <td>
            <s-dyn:text name="contact.phoneNumber" formatType="dashes"
              autocomplete="off" onkeyup="validate(this.form);"/>
          </td>
          <td>
            <span id="contact_phoneNumber" class="error">
              <s:errors field="contact.phoneNumber"/>
            </span>
          </td>
        </tr>
        <tr>
          <td><s:label for="contact.birthDate">Birth date:</s:label></td>
          <td>
            <s-dyn:text name="contact.birthDate" formatPattern="yyyy-MM-dd"
              autocomplete="off" onkeyup="validate(this.form);"/>
          </td>
          <td>
            <span id="contact_birthDate" class="error">
              <s:errors field="contact.birthDate"/>
            </span>
          </td>
        </tr>
        <tr>
          <td><s:label for="contact.gender">Gender:</s:label></td>
          <td class="field">
            <c:forEach var="gender" items="${actionBean.genders}">
              <s:radio name="contact.gender" value="${gender}"/>
              ${gender}
            </c:forEach>
          </td>
        </tr>
        <tr>
          <td>&nbsp;</td>
          <td>
            <s:submit name="save" value="Save"/>
            <s:submit name="cancel" value="Cancel"/>
          </td>
        </tr>
      </table>
      <s:field-metadata var="fmd"/>
      <script type="text/javascript">
      
        $(document).ready(function() {
          validate($('#${fmd.formId}'));
        });
        function validate(form) {
          var params = $(form).serializeArray();
          params.push({name: '_eventName', value: 'validate'});

      
          $.post(form.action, params, function(data) {
      
            /* ... */
      
      
            // Clear out any previous error messages
            var fieldMetadata = ${fmd};
            for (field in fieldMetadata) {
                $(getElement(field)).empty();
            }
            // Display current error messages
            var messages = eval(data);
            for (var field in messages) {
              var message = messages[field];
              var element = getElement(field);
              for (line in message) {
                $('<p></p>').text(message[line]).appendTo(element);
              }
            }
      
          });
      
        }
      
      
        function getElement(field) {
          return '#' + field.replace(/\./g, "_");
        }
      
      </script>
    </s:form>
    <s:messages/>
  </body>
</html>
