<!--
 ! Excerpted from "Stripes: and Java Web Development is Fun Again",
 ! published by The Pragmatic Bookshelf.
 ! Copyrights apply to this code. It may not be used to create training material, 
 ! courses, books, articles, and the like. Contact us if you are in doubt.
 ! We make no guarantees that this code is fit for any purpose. 
 ! Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
-->
<%@ include file="/WEB-INF/jsp/common/taglibs.jsp" %>

<s:layout-render name="/WEB-INF/jsp/common/layout_main.jsp"
  title="Working with data types">
  <s:layout-component name="body">
    <c:if test="${not empty actionBean.context.validationErrors}">
      <p><i>There are ${fn:length(actionBean.context.validationErrors)} errors.</i></p>
    </c:if>
    <s:errors/>
    <div id="typeConverters">
      <s:form beanclass="${actionBean.class}">
        <table class="form">
          <tr>
            <th>Type</th><th>Field</th><th>Value</th>
          </tr>
          <tr class="even">
            <td align="right"><code>byte</code></td>
            <td><s:text name="primitiveByte"/></td>
            <td>${actionBean.primitiveByte}</td>
          </tr>
          <tr class="even">
            <td align="right"><code>Byte</code></td>
            <td><s:text name="wrapperByte"/></td>
            <td>${actionBean.wrapperByte}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>short</code></td>
            <td><s:text name="primitiveShort"/></td>
            <td>${actionBean.primitiveShort}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>Short</code></td>
            <td><s:text name="wrapperShort"/></td>
            <td>${actionBean.wrapperShort}</td>
          </tr>
          <tr class="even">
            <td align="right"><code>int</code></td>
            <td><s:text name="primitiveInt"/></td>
            <td>${actionBean.primitiveInt}</td>
          </tr>
          <tr class="even">
            <td align="right"><code>Integer</code></td>
            <td><s:text name="wrapperInteger"/></td>
            <td>${actionBean.wrapperInteger}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>long</code></td>
            <td><s:text name="primitiveLong"/></td>
            <td>${actionBean.primitiveLong}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>Long</code></td>
            <td><s:text name="wrapperLong"/></td>
            <td>${actionBean.wrapperLong}</td>
          </tr>
          <tr class="even">
            <td align="right"><code>float</code></td>
            <td><s:text name="primitiveFloat"/></td>
            <td>${actionBean.primitiveFloat}</td>
          </tr>
          <tr class="even">
            <td align="right"><code>Float</code></td>
            <td><s:text name="wrapperFloat"/></td>
            <td>${actionBean.wrapperFloat}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>double</code></td>
            <td><s:text name="primitiveDouble"/></td>
            <td>${actionBean.primitiveDouble}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>Double</code></td>
            <td><s:text name="wrapperDouble"/></td>
            <td>${actionBean.wrapperDouble}</td>
          </tr>
          <tr class="even">
            <td align="right"><code>java.math.BigInteger</code></td>
            <td><s:text name="bigInteger"/></td>
            <td>${actionBean.bigInteger}</td>
          </tr>
          <tr class="even">
            <td align="right"><code>java.math.BigDecimal</code></td>
            <td><s:text name="bigDecimal"/></td>
            <td>${actionBean.bigDecimal}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>java.util.Date</code></td>
            <td><s:text name="date"/></td>
            <td>${actionBean.date}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>java.util.Date</code> (time)</td>
            <td><s:text name="time" formatType="time"/></td>
            <td><s:format value="${actionBean.time}" formatType="time"/></td>
          </tr>
          <tr class="even">
            <td align="right"><code>enum</code> (<code>ValidationState</code>)</td>
            <td><s:text name="validationState"/></td>
            <td>${actionBean.validationState}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>boolean</code></td>
            <td><s:text name="primitiveBoolean"/></td>
            <td>${actionBean.primitiveBoolean}</td>
          </tr>
          <tr class="odd">
            <td align="right"><code>Boolean</code></td>
            <td><s:text name="wrapperBoolean"/></td>
            <td>${actionBean.wrapperBoolean}</td>
          </tr>
          <tr class="even">
            <td align="right"><code>char</code></td>
            <td><s:text name="primitiveChar"/></td>
            <td>${actionBean.primitiveChar}</td>
          </tr>
          <tr class="even">
            <td align="right"><code>Character</code></td>
            <td><s:text name="wrapperCharacter"/></td>
            <td>${actionBean.wrapperCharacter}</td>
          </tr>
          <tr class="odd">
            <td align="right">Percentage</td>
            <td><s:text name="percentage"/></td>
            <td>${actionBean.percentage}</td>
          </tr>
          <tr class="even">
            <td align="right">One-to-many (<code>List&lt;Integer&gt;</code>)</td>
            <td><s:text name="oneToMany"/></td>
            <td>${actionBean.oneToMany}</td>
          </tr>
          <tr class="even">
            <td align="right">One-to-many anon (<code>List</code>)</td>
            <td><s:text name="oneToManyAnon"/></td>
            <td>
              ${actionBean.oneToManyAnon}
              <c:forEach var="anon" items="${actionBean.oneToManyAnon}">
                ${anon.class.name}
              </c:forEach>
            </td>
          </tr>
          <tr class="odd">
            <td align="right">Credit card number</td>
            <td><s:text name="creditCardNumber"/></td>
            <td>${actionBean.creditCardNumber}</td>
          </tr>
          <tr>
            <td colspan="3" align="center">
              <s:submit name="view" value="Submit"/>
            </td>
          </tr>
        </table>
      </s:form>
    </div>
    <div id="formatters">
      <s:form beanclass="${actionBean.class}">
        <table class="form">
          <tr>
            <th>Value</th>
            <th>formatType</th>
            <th>formatPattern</th>
            <th>Result</th>
          </tr>
          <tr>
            <td><s:text name="formatDouble"/></td>
            <td>
              <s:select name="doubleFormatType">
                <s:option value="number">number</s:option>
                <s:option value="percentage">percentage</s:option>
                <s:option value="currency">currency</s:option>
              </s:select>
            </td>
            <td>
              <s:select name="doubleFormatPattern">
                <s:option value="plain">plain</s:option>
                <s:option value="integer">integer</s:option>
                <s:option value="decimal">decimal</s:option>
              </s:select>
            </td>
            <td>${actionBean.formattedDouble}</td>
          </tr>
          <tr>
            <td><s:text name="formatDate"/></td>
            <td>
              <s:select name="dateFormatType">
                <s:option value="date">date</s:option>
                <s:option value="time">time</s:option>
                <s:option value="datetime">datetime</s:option>
              </s:select>
            </td>
            <td>
              <s:select name="dateFormatPattern">
                <s:option value="short">short</s:option>
                <s:option value="medium">medium</s:option>
                <s:option value="long">long</s:option>
                <s:option value="full">full</s:option>
              </s:select>
            </td>
            <td>${actionBean.formattedDate}</td>
          </tr>
          <tr>
            <td colspan="4" align="center">
              <s:submit name="view" value="Submit"/>
            </td>
          </tr>
        </table>
      </s:form>
    </div>
    <div class="clear"></div>
  </s:layout-component>
</s:layout-render>
