/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.action;

import java.util.List;

import stripesbook.dao.ContactDao;
import stripesbook.dao.mock.MockContactDao;
import stripesbook.model.Contact;
import net.sourceforge.stripes.action.DefaultHandler;
import net.sourceforge.stripes.action.ForwardResolution;
import net.sourceforge.stripes.action.RedirectResolution;
import net.sourceforge.stripes.action.Resolution;

public class ContactListActionBean extends BaseActionBean {
    private static final String LIST="/WEB-INF/jsp/contact_list.jsp";
    
    private static final String VIEW="/WEB-INF/jsp/contact_view.jsp";
    

    @DefaultHandler
    public Resolution list() {
        return new ForwardResolution(LIST);
    }

    
    public Resolution view() {
        return new ForwardResolution(VIEW);
    }
    

    
    public Resolution delete() {
        contactDao.delete(contactId);
        return new RedirectResolution(getClass());
    }
    

    
    private Integer contactId;

    public void setContactId(Integer id) {
        contactId = id;
    }
    

    
    public Contact getContact() {
        return contactDao.read(contactId);
    }
    
    public List<Contact> getContacts() {
        return contactDao.read();
    }
    private ContactDao contactDao = MockContactDao.getInstance();
}
