<!--
 ! Excerpted from "Stripes: and Java Web Development is Fun Again",
 ! published by The Pragmatic Bookshelf.
 ! Copyrights apply to this code. It may not be used to create training material, 
 ! courses, books, articles, and the like. Contact us if you are in doubt.
 ! We make no guarantees that this code is fit for any purpose. 
 ! Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
-->
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<fmt:message var="title" key="contactList.title"/>
<s:layout-render name="/WEB-INF/jsp/common/layout_menu.jsp"
  title="${title}" currentSection="ContactList">
  <s:layout-component name="body">
    <s:link beanclass="stripesbook.action.ContactFormActionBean">
      <fmt:message key="contactList.createNewContact"/>
    </s:link>
    <br/>
    <d:table name="${actionBean.contacts}" id="contact" requestURI=""
      defaultsort="1" pagesize="10">
      <d:column titleKey="contact.lastName" property="lastName"
        sortable="true"/>
      <d:column titleKey="contact.firstName" property="firstName"
        sortable="true"/>
      <d:column titleKey="contact.email" property="email" sortable="true"/>
      <d:column titleKey="contactList.action">
        <s:link beanclass="stripesbook.action.ContactListActionBean"
          event="view">
          <s:param name="contact" value="${contact}"/>
          <fmt:message key="contactList.view"/>
        </s:link> |
        <s:link beanclass="stripesbook.action.ContactFormActionBean">
          <s:param name="contact" value="${contact}"/>
          <fmt:message key="contactList.update"/>
        </s:link> |
        <fmt:message var="delete" key="contactList.delete"/>
        <s:link beanclass="stripesbook.action.ContactListActionBean"
          event="delete"
          onclick="return confirm('${delete} ${contact}?');">
          <s:param name="contact" value="${contact}"/>
          ${delete}
        </s:link>
      </d:column>
    </d:table>
    <c:if test="${empty actionBean.contacts}">
      <p>
        <s:link beanclass="stripesbook.action.MockDataLoaderActionBean"
                event="loadMockContacts">
          <fmt:message key="contactList.loadMockContacts"/>
        </s:link>
      </p>
    </c:if>
  </s:layout-component>
</s:layout-render>
