/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.dao.mock;

import org.springframework.stereotype.Repository;
import java.io.File;
import stripesbook.dao.AttachmentDao;
import stripesbook.model.Attachment;

@Repository("attachmentDao")
public class MockAttachmentDao extends MockDao<Attachment>
    implements AttachmentDao
{
    private static final String DIRECTORY =
        System.getProperty("user.home") + File.separator +
            "webmail_attachments" + File.separator;

    public String getFilePath(Attachment attachment) {
        return DIRECTORY + attachment.getId() + "_" +
            attachment.getFileName();
    }
    public void deleteFile(Attachment attachment) {
        new File(getFilePath(attachment)).delete();
    }
}
