/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.dao.mock;

import org.springframework.stereotype.Repository;
import stripesbook.dao.ContactDao;
import stripesbook.model.Contact;
import stripesbook.model.User;

@Repository("contactDao")
public class MockContactDao extends MockDao<Contact>
    implements ContactDao
{
    @Override
    public void save(Contact contact) {
        contact.getUser().getContacts().add(contact);
        super.save(contact);
    }
    public Contact findByEmail(String email, User user) {
        Contact result = null;
        for (Contact contact : read()) {
            if (email.equals(contact.getEmail())) {
                result = contact;
                break;
            }
        }
        return result;
    }
}
