/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.dao.mock;

import java.util.HashSet;
import org.springframework.stereotype.Repository;
import stripesbook.dao.FolderDao;
import stripesbook.model.Folder;
import stripesbook.model.Message;
import stripesbook.model.User;

@Repository("folderDao")
public class MockFolderDao extends MockDao<Folder>
    implements FolderDao
{
    @Override
    public void save(Folder folder) {
        if (folder.getMessages() == null) {
            folder.setMessages(new HashSet<Message>());
        }
        folder.getUser().getFolders().add(folder);
        super.save(folder);
    }
    public Folder findByName(String name, User user) {
        for (Folder folder : read()) {
            if (folder.getName().equals(name)) {
                return folder;
            }
        }
        return null;
    }
}
