/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.dao.mock;

import java.util.Collection;
import org.springframework.stereotype.Repository;
import stripesbook.dao.MessageDao;
import stripesbook.model.Folder;
import stripesbook.model.Message;

@Repository("messageDao")
public class MockMessageDao extends MockDao<Message>
    implements MessageDao
{
    public void addMessageToFolder(Message message, Folder folder) {
        message.setFolder(folder);
        folder.getMessages().add(message);
    }
    public void addMessagesToFolder(Collection<Message> messages,
        Folder folder)
    {
        for (Message message : messages) {
            addMessageToFolder(message, folder);
        }
    }
    public void deleteMessages(Collection<Message> messages) {
        for (Message message : messages) {
            message.getFolder().getMessages().remove(message);
        }
    }
}
