/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.dao.mock;

import java.util.ArrayList;
import java.util.HashSet;
import org.springframework.stereotype.Repository;
import stripesbook.dao.UserDao;
import stripesbook.model.Alias;
import stripesbook.model.Contact;
import stripesbook.model.Folder;
import stripesbook.model.User;

@Repository("userDao")
public class MockUserDao extends MockDao<User>
    implements UserDao
{
    @Override
    public void save(User user) {
        if (user.getFolders() == null) {
            user.setFolders(new ArrayList<Folder>());
        }
        if (user.getContacts() == null) {
            user.setContacts(new HashSet<Contact>());
        }
        if (user.getAliases() == null) {
            user.setAliases(new HashSet<Alias>());
        }
        super.save(user);
    }
    public User findByUsername(String username) {
        User result = null;
        for (User user : read()) {
            if (username.equals(user.getUsername())) {
                result = user;
                break;
            }
        }
        return result;
    }
}
