/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/

package stripesbook.test.plainmock;


import java.util.ArrayList;
import java.util.Collection;
import net.sourceforge.stripes.validation.TypeConverter;
import net.sourceforge.stripes.validation.ValidationError;
import org.junit.Before;
import org.junit.Test;
import stripesbook.ext.PhoneNumberTypeConverterFormatter;
import stripesbook.model.PhoneNumber;


import static org.junit.Assert.*;

public class PhoneNumberTypeConverterTest {
    private TypeConverter<PhoneNumber> typeConverter;
    private Collection<ValidationError> errors;

    @Before
    public void setup() {
        typeConverter = new PhoneNumberTypeConverterFormatter();
        errors = new ArrayList<ValidationError>();
    }
    @Test
    public void testValidPhoneNumber() {
        PhoneNumber phoneNumber = typeConverter.convert(
            "(555) 444.6667", PhoneNumber.class, errors);

        assertEquals(0, errors.size());
        assertEquals("555", phoneNumber.getAreaCode());
        assertEquals("444", phoneNumber.getPrefix());
        assertEquals("6667", phoneNumber.getSuffix());
    }
    @Test
    public void testInvalidPhoneNumber() {
        PhoneNumber phoneNumber = typeConverter.convert(
            " 55 444.667  ", PhoneNumber.class, errors);
        assertNull(phoneNumber);
        assertEquals(1, errors.size());
    }
}

