<!--
 ! Excerpted from "Stripes: and Java Web Development is Fun Again",
 ! published by The Pragmatic Bookshelf.
 ! Copyrights apply to this code. It may not be used to create training material, 
 ! courses, books, articles, and the like. Contact us if you are in doubt.
 ! We make no guarantees that this code is fit for any purpose. 
 ! Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
-->
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<fmt:message var="title" key="messageCompose.title"/>
<s:layout-render name="/WEB-INF/jsp/common/layout_menu.jsp"
  title="${title}" currentSection="Compose">

  <s:useActionBean beanclass="stripesbook.action.ContactListActionBean"
    id="contacts"/>

  <s:layout-component name="body">
    <s:form beanclass="stripesbook.action.MessageComposeActionBean">
      <s:errors field="message.to"/>
      <s:errors field="message.subject"/>
      <div>
        <table id="compose">
          <c:set var="arrow" value="/images/arrow.png"/>
          <tr>
            <th><s:label for="message.to"/>:</th>
            <td><s:text name="message.to" size="60"/></td>
            <td><s:image name="addTo" src="${arrow}"/></td>
            <td rowspan="4">
              <s:select name="contacts" multiple="true" size="7">
                <s:options-collection collection="${contacts.contacts}"
                  value="id" sort="firstName"/>
              </s:select>
            </td>
          </tr>
          <tr>
            <th><s:label for="message.cc"/>:</th>
            <td><s:text name="message.cc" size="60"/></td>
            <td><s:image name="addCc" src="${arrow}"/></td>
          </tr>
          <tr>
            <th><s:label for="message.bcc"/>:</th>
            <td><s:text name="message.bcc" size="60"/></td>
            <td><s:image name="addBcc" src="${arrow}"/></td>
          </tr>
          <tr>
            <th><s:label for="message.subject"/>:</th>
            <td colspan="2">
              <s:text name="message.subject" size="60"/>
            </td>
          </tr>
          <tr>
            <td colspan="4">
              <s:textarea name="message.text" cols="87" rows="12"/>
            </td>
          </tr>
        </table>
      </div>
      <div><fmt:message key="messageCompose.attachments"/>:</div>
      <div><s:errors field="attachments"/></div>
      <div class="left">
        <c:forEach var="index" begin="0" end="3">
          <div><s:file name="attachments[${index}]"/></div>
        </c:forEach>
      </div>
      <div class="left">
        <s:submit name="upload" value="Upload"/>
      </div>
      <div class="left">
        <s:hidden id="deleteIndex" name="deleteIndex"/>
        <c:forEach items="${actionBean.message.attachments}"
          var="attach" varStatus="loop">
          <s:image name="deleteAttachment" src="/images/delete.gif"
            onclick="getElementById('deleteIndex').value=${loop.index}"
            style="border: none; vertical-align: bottom"/>
          ${attach.fileName} (${attach.size} bytes)
          <br/>
        </c:forEach>
      </div>
      <div class="clear"></div>
      <div id="buttons">
        <s:submit name="send"/>
        <s:submit name="cancel"/>
      </div>
    </s:form>
  </s:layout-component>
</s:layout-render>
