/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.ext;

import net.sourceforge.stripes.controller.NameBasedActionResolver;

public class MyActionResolver extends NameBasedActionResolver {
    @Override
    protected String getBindingSuffix() {
        return "";
    }
    @Override
    protected String getUrlBinding(String actionBeanName) {
        String result = super.getUrlBinding(actionBeanName);
        result = convertToLowerCaseWithUnderscores(result);
        return result;
    }
    private String convertToLowerCaseWithUnderscores(String string) {
        StringBuilder builder = new StringBuilder();
        for (int i = 0, t = string.length(); i < t; i++) {
            char ch = string.charAt(i);
            if (Character.isUpperCase(ch)) {
                ch = Character.toLowerCase(ch);
                if (i > 1) {
                    builder.append('_');
                }
            }
            builder.append(ch);
        }
        return builder.toString();
    }
}
