<!--
 ! Excerpted from "Stripes: and Java Web Development is Fun Again",
 ! published by The Pragmatic Bookshelf.
 ! Copyrights apply to this code. It may not be used to create training material, 
 ! courses, books, articles, and the like. Contact us if you are in doubt.
 ! We make no guarantees that this code is fit for any purpose. 
 ! Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
-->
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>
<c:set var="folder" value="${actionBean.context.currentFolder}"/>
<script type="text/javascript">
  function checkAll(form, value) {
    for (var i in form.selectedMessages) {
      form.selectedMessages[i].checked = value;
    }
  }
</script>
<c:set var="checkAll">
  <input type="checkbox" onclick="checkAll(this.form, this.checked);">
</c:set>
<fmt:message var="title" key="messageList.title"/>
<s:layout-render name="/WEB-INF/jsp/common/layout_folders.jsp"
  title="${title}" currentSection="MessageList">
  <s:layout-component name="body">
    <s:form beanclass="stripesbook.action.MessageListActionBean">
      <d:table name="${folder.messages}" requestURI="" id="message"
        defaultsort="2" defaultorder="descending" pagesize="10">
        <d:column title="${checkAll}">
          <s:checkbox name="selectedMessages" value="${message.id}"/>
        </d:column>
        <d:column titleKey="messageList.date" sortable="true">
          <s:format value="${message.date}"
            formatPattern="yyyy-MM-dd HH:mm"/>
        </d:column>
        <d:column titleKey="messageList.from" sortable="true">
          ${fn:escapeXml(message.from)}
        </d:column>
        <d:column titleKey="messageList.to" sortable="true">
          ${fn:escapeXml(message.to)}
        </d:column>
        <d:column titleKey="messageList.subject" sortable="true">
          <s:link
            beanclass="stripesbook.action.MessageDetailsActionBean">
            <s:param name="message" value="${message.id}"/>
            ${fn:escapeXml(message.subject)}
          </s:link>
        </d:column>
      </d:table>
      <c:if test="${not empty folder.messages}">
        <div>
          <s:errors field="selectedMessages"/>
        </div>
        <%@include file="/WEB-INF/jsp/common/message_action.jsp"%>
      </c:if>
    </s:form>
    <c:if test="${empty folder.messages}">
      <p>
        <s:link beanclass="stripesbook.action.MockDataLoaderActionBean"
                event="loadMockMessages">
          <fmt:message key="messageList.loadMockMessages"/>
        </s:link>
      </p>
    </c:if>
  </s:layout-component>
</s:layout-render>
