<!--
 ! Excerpted from "Stripes: and Java Web Development is Fun Again",
 ! published by The Pragmatic Bookshelf.
 ! Copyrights apply to this code. It may not be used to create training material, 
 ! courses, books, articles, and the like. Contact us if you are in doubt.
 ! We make no guarantees that this code is fit for any purpose. 
 ! Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
-->
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>
<script type="text/javascript" src="${contextPath}/js/contact_form.js">
</script>
<s:form id="form" beanclass="${actionBean.class}">
  <div><s:hidden name="contact"/></div>
  <table class="form">
    <tr>
      <td><s:label for="contact.email"/>:</td>
      <td>
        <s:text name="contact.email" class="required"/>
      </td>
      <td class="error"><s:errors field="contact.email"/></td>
    </tr>
    <tr>
      <td><s:label for="contact.firstName"/>:</td>
      <td>
        <s:text name="contact.firstName"/>
      </td>
      <td class="error"><s:errors field="contact.firstName"/></td>
    </tr>
    <tr>
      <td><s:label for="contact.lastName"/>:</td>
      <td>
        <s:text name="contact.lastName"/>
      </td>
      <td class="error"><s:errors field="contact.lastName"/></td>
    </tr>
    <tr>
      <td><s:label for="contact.phoneNumber"/>:</td>
      <td>
        <s:text name="contact.phoneNumber" formatType="dashes"/>
      </td>
      <td class="error"><s:errors field="contact.phoneNumber"/></td>
    </tr>
    <tr>
      <td><s:label for="contact.birthDate"/>:</td>
      <td>
        <s:text name="contact.birthDate" formatPattern="yyyy-MM-dd"/>
      </td>
      <td class="error"><s:errors field="contact.birthDate"/></td>
    </tr>
    <tr>
      <td><s:label for="contact.gender"/>:</td>
      <td class="field">
        <c:forEach var="gender" items="${actionBean.genders}">
          <s:radio name="contact.gender" value="${gender}"/>
          <fmt:message key="${gender}"/>
        </c:forEach>
      </td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>
        <%-- START:save --%>
        <s:submit name="save" onclick="return submitForm(this);"/>
        <%-- END:save --%>
        <%-- START:cancel --%>
        <s:button name="cancel" onclick="$('#contact_form').hide();"/>
        <%-- END:cancel --%>
      </td>
    </tr>
  </table>
</s:form>
