/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.action;

import java.util.List;
import java.util.Map;

import net.sourceforge.stripes.action.DefaultHandler;
import net.sourceforge.stripes.action.FileBean;
import net.sourceforge.stripes.action.ForwardResolution;
import net.sourceforge.stripes.action.Resolution;
import net.sourceforge.stripes.validation.Validate;
import net.sourceforge.stripes.validation.ValidateNestedProperties;
import stripesbook.model.Option;
import stripesbook.model.OptionEnum;

public class FormControlsActionBean extends BaseActionBean {
    private static final String VIEW = "/WEB-INF/jsp/form_controls.jsp";

    @DefaultHandler
    public Resolution view() {
        return new ForwardResolution(VIEW);
    }
    public Resolution show() {
        return new ForwardResolution(VIEW);
    }

    private boolean subscribe;
    public boolean isSubscribe() { return subscribe; }
    public void setSubscribe(boolean value) { subscribe = value; }

    public List<String> getAvailableOptionStrings() {
        return Option.getOptionStrings();
    }
    public List<String> getAvailableOptionNames() {
        return Option.getOptionNames();
    }
    public List<Option> getAvailableOptions() {
        return Option.getOptions();
    }
    public Map<Integer,Option> getAvailableOptionsMap() {
        return Option.getOptionsMap();
    }

    private List<String> selectedOptionStrings;
    public List<String> getSelectedOptionStrings() {
        return selectedOptionStrings;
    }
    public void setSelectedOptionStrings(List<String> value) {
        this.selectedOptionStrings = value;
    }

    private List<Option> selectedOptions;
    public List<Option> getSelectedOptions() {
        return selectedOptions;
    }
    public void setSelectedOptions(List<Option> value) {
        this.selectedOptions = value;
    }

    private Map<String,Boolean> checkboxMap;
    public Map<String,Boolean> getCheckboxMap() {
        return checkboxMap;
    }
    public void setCheckboxMap(Map<String,Boolean> checkboxMap) {
        this.checkboxMap = checkboxMap;
    }

    private Map<Integer,Option> typedMap;
    public Map<Integer,Option> getTypedMap() {
        return typedMap;
    }
    public void setTypedMap(Map<Integer,Option> typedMap) {
        this.typedMap = typedMap;
    }

    private String selectedOptionString;
    public String getSelectedOptionString() {
        return selectedOptionString;
    }
    public void setSelectedOptionString(String selectedOptionString) {
        this.selectedOptionString = selectedOptionString;
    }
    private Option selectedOption;
    public Option getSelectedOption() {
        return selectedOption;
    }
    public void setSelectedOption(Option selectedOption) {
        this.selectedOption = selectedOption;
    }

    private String selectOptionString;
    public String getSelectOptionString() {
        return selectOptionString;
    }
    public void setSelectOptionString(String selectOptionString) {
        this.selectOptionString = selectOptionString;
    }
    private Option selectOption;
    public Option getSelectOption() {
        return selectOption;
    }
    public void setSelectOption(Option selectOption) {
        this.selectOption = selectOption;
    }
    private OptionEnum optionEnum;
    public OptionEnum getOptionEnum() {
        return optionEnum;
    }
    public void setOptionEnum(OptionEnum optionEnum) {
        this.optionEnum = optionEnum;
    }
    private OptionEnum optionEnumLabel;
    public OptionEnum getOptionEnumLabel() {
        return optionEnumLabel;
    }
    public void setOptionEnumLabel(OptionEnum optionEnumLabel) {
        this.optionEnumLabel = optionEnumLabel;
    }
    private Integer optionIdFromMap;
    public Integer getOptionIdFromMap() {
        return optionIdFromMap;
    }
    public void setOptionIdFromMap(Integer optionIdFromMap) {
        this.optionIdFromMap = optionIdFromMap;
    }
    private Option optionFromMap;
    public Option getOptionFromMap() {
        return optionFromMap;
    }
    public void setOptionFromMap(Option optionFromMap) {
        this.optionFromMap = optionFromMap;
    }
    private List<String> selectOptionsString;
    public List<String> getSelectOptionsString() {
        return selectOptionsString;
    }
    public void setSelectOptionsString(List<String> selectOptionsString) {
        this.selectOptionsString = selectOptionsString;
    }
    private List<Option> selectOptions;
    public List<Option> getSelectOptions() {
        return selectOptions;
    }
    public void setSelectOptions(List<Option> selectOptions) {
        this.selectOptions = selectOptions;
    }
    private List<OptionEnum> optionsEnum;
    public List<OptionEnum> getOptionsEnum() {
        return optionsEnum;
    }
    public void setOptionsEnum(List<OptionEnum> optionsEnum) {
        this.optionsEnum = optionsEnum;
    }
    private List<OptionEnum> optionsEnumLabel;
    public List<OptionEnum> getOptionsEnumLabel() {
        return optionsEnumLabel;
    }
    public void setOptionsEnumLabel(List<OptionEnum> optionsEnumLabel) {
        this.optionsEnumLabel = optionsEnumLabel;
    }
    private List<Integer> optionIdsFromMap;
    public List<Integer> getOptionIdsFromMap() {
        return optionIdsFromMap;
    }
    public void setOptionIdsFromMap(List<Integer> optionIdsFromMap) {
        this.optionIdsFromMap = optionIdsFromMap;
    }
    private List<Option> optionsFromMap;
    public List<Option> getOptionsFromMap() {
        return optionsFromMap;
    }
    public void setOptionsFromMap(List<Option> optionsFromMap) {
        this.optionsFromMap = optionsFromMap;
    }

    private String text;
    public String getText() {
        return text;
    }
    public void setText(String text) {
        this.text = text;
    }

    private FileBean file;
    public FileBean getFile() {
        return file;
    }
    public void setFile(FileBean file) {
        this.file = file;
    }

    private List<String> indexedStrings;
    public List<String> getIndexedStrings() {
        return indexedStrings;
    }
    public void setIndexedStrings(List<String> indexedStrings) {
        this.indexedStrings = indexedStrings;
    }

    private List<FileBean> files;
    public List<FileBean> getFiles() {
        return files;
    }
    public void setFiles(List<FileBean> files) {
        this.files = files;
    }

    @ValidateNestedProperties({
        @Validate(field="id", required=true, on="show"),
        @Validate(field="name", required=true, on="show")
    })
    private List<Option> indexedOptions;
    public List<Option> getIndexedOptions() {
        return indexedOptions;
    }
    public void setIndexedOptions(List<Option> indexedOptions) {
        this.indexedOptions = indexedOptions;
    }

    @ValidateNestedProperties({
        @Validate(field="id", required=true, on="show"),
        @Validate(field="name", required=true, on="show")
    })
    private Map<String,Option> indexedMap;
    public Map<String,Option> getIndexedMap() {
        return indexedMap;
    }
    public void setIndexedMap(Map<String,Option> indexedMap) {
        this.indexedMap = indexedMap;
    }

    private boolean tintedWindows;
    public boolean getTintedWindows() {
        return tintedWindows;
    }
    public void setTintedWindows(boolean tintedWindows) {
        this.tintedWindows = tintedWindows;
    }
    private boolean magWheels;
    public boolean getMagWheels() {
        return magWheels;
    }
    public void setMagWheels(boolean magWheels) {
        this.magWheels = magWheels;
    }
    private boolean sunroof;
    public boolean getSunroof() {
        return sunroof;
    }
    public void setSunroof(boolean sunroof) {
        this.sunroof = sunroof;
    }
    private boolean leatherSeats;
    public boolean getLeatherSeats() {
        return leatherSeats;
    }
    public void setLeatherSeats(boolean leatherSeats) {
        this.leatherSeats = leatherSeats;
    }

    private Integer someProperty;
    public Integer getSomeProperty() {
        return someProperty;
    }
    public void setSomeProperty(Integer someProperty) {
        this.someProperty = someProperty;
    }
}
