/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.model;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Option {
    private static List<Option> options = Arrays.asList(
        new Option(0, "Tinted windows"),
        new Option(1, "Mag wheels"),
        new Option(2, "Sunroof"),
        new Option(3, "Leather seats")
    );
    private static Map<Integer,Option> optionsMap =
        new HashMap<Integer,Option>();
    static {
        for (int i = 0, t = options.size(); i < t; i++) {
            optionsMap.put(i, options.get(i));
        }
    }
    public static List<String> getOptionStrings() {
        return Arrays.asList(
            "Tinted windows", "Mag wheels", "Sunroof", "Leather seats"
        );
    }
    public static List<String> getOptionNames() {
        return Arrays.asList(
            "tintedWindows", "magWheels", "sunroof", "leatherSeats"
        );
    }
    public static List<Option> getOptions() {
        return options;
    }
    public static Map<Integer,Option> getOptionsMap() {
        return optionsMap;
    }
    public Option() {
    }
    public Option(int id, String name) {
        setId(id);
        setName(name);
    }
    public Option(String stringId) {
        String[] parts = stringId.split("_");
        setId(Integer.parseInt(parts[0]));
        setName(parts[1]);
    }
    private int id;
    public int getId() {
        return id;
    }
    public void setId(int id) {
        this.id = id;
    }
    private String name;
    public String getName() {
        return name;
    }
    public void setName(String name) {
        this.name = name;
    }
    public String getIdString() {
        return String.format("%s_%s", id, name);
    }
    @Override
    public String toString() {
        return name;
    }
}
