<!--
 ! Excerpted from "Stripes: and Java Web Development is Fun Again",
 ! published by The Pragmatic Bookshelf.
 ! Copyrights apply to this code. It may not be used to create training material, 
 ! courses, books, articles, and the like. Contact us if you are in doubt.
 ! We make no guarantees that this code is fit for any purpose. 
 ! Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
-->
<%@ include file="/WEB-INF/jsp/common/taglibs.jsp" %>

<s:layout-render name="/WEB-INF/jsp/common/layout_main.jsp"
  title="Working with form controls">
  <s:layout-component name="body">
    <s:form beanclass="stripesbook.action.FormControlsActionBean">
      <s:errors/>
      <s:submit name="show"/>
      <div class="column">
        <h1>Checkboxes:</h1>

        <div class="row">
          <h2>True/False:</h2>
          <p>
            <s:checkbox name="subscribe"/>Subscribe to newsletter?
          </p>
          <p class="result">Result: ${actionBean.subscribe}</p>
        </div>

        <div class="row">
          <h2>List&lt;String&gt;:</h2>
          <p>
            <c:forEach var="option" items="${actionBean.availableOptionStrings}">
              <s:checkbox name="selectedOptionStrings" value="${option}"/>
              ${option}
              <br/>
            </c:forEach>
          </p>
          <p class="result">Result: ${actionBean.selectedOptionStrings}</p>
        </div>

        <div class="row">
          <h2>List&lt;Option&gt;:</h2>
          <p>
            <c:forEach var="option" items="${actionBean.availableOptions}">
              <s:checkbox name="selectedOptions" value="${option.id}_${option.name}"/>
              ${option.name}
              <br/>
            </c:forEach>
          </p>
          <p class="result">Result: ${actionBean.selectedOptions}</p>
        </div>

        <div class="row">
          <h2>Map&lt;String,Boolean&gt;:</h2>
          <p>
            <c:forEach var="option" items="${actionBean.availableOptionStrings}">
              <s:checkbox name="checkboxMap['${option}']" value="true"/>
              ${option}
              <br/>
            </c:forEach>
          </p>
          <p class="result">Result: ${actionBean.checkboxMap}</p>
        </div>

        <div class="row">
          <h2>Map&lt;Integer,Option&gt;:</h2>
          <p>
            <c:forEach var="option" varStatus="loop" items="${actionBean.availableOptions}">
              <s:checkbox name="typedMap.${loop.index}" value="${option.id}_${option.name}"/>
              ${option}
              <br/>
            </c:forEach>
          </p>
          <p class="result">Result: ${actionBean.typedMap}</p>
        </div>

        <div class="row">
          <h2><code>setProperty(boolean)</code>:</h2>
          <p>
            <c:forEach var="option" items="${actionBean.availableOptionNames}">
              <s:checkbox name="${option}"/>
              ${option}
              <br/>
            </c:forEach>
          </p>
          <p class="result">Result:<br/>
            <c:forEach var="option" items="${actionBean.availableOptionNames}">
              ${option}: ${actionBean[option]}
              <br/>
            </c:forEach>
          </p>
        </div>

        <div class="row">
          <h2><code>setProperty(T)</code>:</h2>
          <p>
            <s:checkbox name="someProperty" value="5"/>setSomeProperty(5)
          </p>
          <p class="result">Result: someProperty = ${actionBean.someProperty}</p>
        </div>
      </div>
      <div class="column">
        <h1>Radio buttons:</h1>
        <div class="row">
          <h2>String:</h2>
          <p>
            <c:forEach var="option" items="${actionBean.availableOptionStrings}">
              <s:radio name="selectedOptionString" value="${option}"/>
              ${option}
              <br/>
            </c:forEach>
          </p>
          <p class="result">Result: ${actionBean.selectedOptionString}</p>
        </div>

        <div class="row">
          <h2>Option:</h2>
          <p>
            <c:forEach var="option" items="${actionBean.availableOptions}">
              <s:radio name="selectedOption" value="${option.idString}"/>
              ${option.name}
              <br/>
            </c:forEach>
          </p>
          <p class="result">Result: ${actionBean.selectedOption}</p>
        </div>
      </div>
      <div class="column">
        <h1>Select boxes/Single:</h1>
        <div class="row">
          <h2>String/Collection:</h2>
          <s:select name="selectOptionString">
            <s:option value="" label="Select an option..."/>
            <s:options-collection collection="${actionBean.availableOptionStrings}"/>
          </s:select>
          <p class="result">Result: ${actionBean.selectOptionString}</p>
        </div>
        <div class="row">
          <h2>Option/Collection:</h2>
          <s:select name="selectOption">
            <s:option value="" label="Select an option..."/>
            <s:options-collection collection="${actionBean.availableOptions}"
              value="idString" label="name"/>
          </s:select>
          <p class="result">Result: ${actionBean.selectOption}</p>
        </div>
        <div class="row">
          <h2>Option/Enumeration:</h2>
          <s:select name="optionEnum">
            <s:option value="" label="Select an option..."/>
            <s:options-enumeration enum="stripesbook.model.OptionEnum"/>
          </s:select>
          <p class="result">Result: ${actionBean.optionEnum}</p>
        </div>
        <div class="row">
          <h2>Option/Enumeration:</h2>
          <s:select name="optionEnumLabel">
            <s:option value="" label="Select an option..."/>
            <s:options-enumeration enum="stripesbook.model.OptionEnum"
              label="myLabel"/>
          </s:select>
          <p class="result">Result: ${actionBean.optionEnumLabel.myLabel}</p>
        </div>
        <div class="row">
          <h2>Option/Map:</h2>
          <s:select name="optionIdFromMap">
            <s:option value="" label="Select an option..."/>
            <s:options-map map="${actionBean.availableOptionsMap}"/>
          </s:select>
          <p class="result">Result: ${actionBean.optionIdFromMap}</p>
        </div>
        <div class="row">
          <h2>Option/Map:</h2>
          <s:select name="optionFromMap">
            <s:option value="" label="Select an option..."/>
            <s:options-map map="${actionBean.availableOptionsMap}"
              sort="value" value="value.idString"/>
          </s:select>
          <p class="result">Result: ${actionBean.optionFromMap}</p>
        </div>
      </div>
      <div class="column">
        <h1>Select boxes/Multiple:</h1>
        <div class="row">
          <h2>String/Collection:</h2>
          <s:select name="selectOptionsString" multiple="true">
            <s:options-collection collection="${actionBean.availableOptionStrings}"/>
          </s:select>
          <p class="result">Result: ${actionBean.selectOptionsString}</p>
        </div>
        <div class="row">
          <h2>Option/Collection:</h2>
          <s:select name="selectOptions" multiple="true">
            <s:options-collection collection="${actionBean.availableOptions}"
              value="idString" label="name"/>
          </s:select>
          <p class="result">Result: ${actionBean.selectOptions}</p>
        </div>
        <div class="row">
          <h2>Option/Enumeration:</h2>
          <s:select name="optionsEnum" multiple="true">
            <s:options-enumeration enum="stripesbook.model.OptionEnum"/>
          </s:select>
          <p class="result">Result: ${actionBean.optionsEnum}</p>
        </div>
        <div class="row">
          <h2>Option/Enumeration:</h2>
          <s:select name="optionsEnumLabel" multiple="true">
            <s:options-enumeration enum="stripesbook.model.OptionEnum"
              label="myLabel"/>
          </s:select>
          <p>
            Result: [
              <c:forEach var="option" items="${actionBean.optionsEnumLabel}">
                ${option.myLabel}
              </c:forEach>
            ]
          </p>
        </div>
        <div class="row">
          <h2>Option/Map:</h2>
          <s:select name="optionIdsFromMap" multiple="true">
            <s:options-map map="${actionBean.availableOptionsMap}"/>
          </s:select>
          <p class="result">Result: ${actionBean.optionIdsFromMap}</p>
        </div>
        <div class="row">
          <h2>Option/Map:</h2>
          <s:select name="optionsFromMap" multiple="true">
            <s:options-map map="${actionBean.availableOptionsMap}"
              sort="value" value="value.idString"/>
          </s:select>
          <p class="result">Result: ${actionBean.optionsFromMap}</p>
        </div>
      </div>
      <div class="column">
        <h1>Text area:</h1>
        <br/>
        <s:textarea name="text"/>
        <p class="result">Result: <pre>${actionBean.text}</pre></p>
      </div>
      <div class="column">
        <h1>File upload:</h1>
        <br/>
        <s:file name="file"/>
        <p>File name: ${actionBean.file.fileName}</p>
        <p>File size: ${actionBean.file.size}</p>
      </div>
      <div class="column">
        <h1>Indexed properties:</h1>
        <div class="row">
          <h2>Strings:</h2>
          <p>
            <s:text name="indexedStrings[0]"/><br/>
            <s:text name="indexedStrings[1]"/><br/>
            <s:text name="indexedStrings[2]"/><br/>
            <s:text name="indexedStrings[3]"/><br/>
          </p>
          <p class="result">Result: ${actionBean.indexedStrings}</p>
        </div>
        <div class="row">
          <h2>Files:</h2>
          <p>
            <s:file name="files[0]"/><br/>
            <s:file name="files[1]"/><br/>
          </p>
          <p class="result">Result: ${actionBean.files}</p>
        </div>
        <div class="row">
          <h2>Options:</h2>
          <p>
            <s:text name="indexedOptions[0].id"/><s:text name="indexedOptions[0].name"/><br/>
            <s:text name="indexedOptions[1].id"/><s:text name="indexedOptions[1].name"/><br/>
            <s:text name="indexedOptions[2].id"/><s:text name="indexedOptions[2].name"/><br/>
            <s:text name="indexedOptions[3].id"/><s:text name="indexedOptions[3].name"/><br/>
          </p>
          <p class="result">Result: ${actionBean.indexedOptions}</p>
        </div>
        <div class="row">
          <h2>Map:</h2>
          <p>
            <s:text name="indexedMap['Fred'].id"/><s:text name="indexedMap['Fred'].name"/><br/>
            <s:text name="indexedMap['Nadia'].id"/><s:text name="indexedMap['Nadia'].name"/><br/>
            <s:text name="indexedMap['Lily'].id"/><s:text name="indexedMap['Lily'].name"/><br/>
          </p>
          <p class="result">Result: ${actionBean.indexedMap}</p>
        </div>
      </div>
      <div class="clear"></div>
    </s:form>
  </s:layout-component>
</s:layout-render>
