/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.test.stripesmock;

import java.util.HashMap;
import java.util.Map;
import net.sourceforge.stripes.controller.DispatcherServlet;
import net.sourceforge.stripes.controller.StripesFilter;
import net.sourceforge.stripes.mock.MockRoundtrip;
import net.sourceforge.stripes.mock.MockServletContext;
import org.junit.BeforeClass;
import org.junit.Test;
import stripesbook.action.BaseActionBean;

import static org.junit.Assert.*;

public class InterceptorOrderTest {
    private static MockServletContext mockServletContext;

    @BeforeClass
    public static void setup() throws Exception {
        mockServletContext = new MockServletContext("webmail");

        Map<String,String> params = new HashMap<String,String>();
        params.put("ActionResolver.Packages", "stripesbook.action");
        params.put("Interceptor.Classes",
            "stripesbook.nonext.Interceptor1,"
          + "stripesbook.nonext.Interceptor2,"
          + "stripesbook.nonext.Interceptor3"
        );
        mockServletContext.addFilter(StripesFilter.class,
            "StripesFilter", params);

        mockServletContext.setServlet(DispatcherServlet.class,
            "DispatcherServlet", null);
    }
    @Test
    public void test() throws Exception {
        MockRoundtrip trip = new MockRoundtrip(mockServletContext,
            BaseActionBean.class);

        trip.execute();
    }
}
