/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.action;

import javax.annotation.security.DenyAll;
import javax.annotation.security.PermitAll;
import javax.annotation.security.RolesAllowed;
import net.sourceforge.stripes.action.DefaultHandler;
import net.sourceforge.stripes.action.ForwardResolution;
import net.sourceforge.stripes.action.Resolution;
import stripesbook.model.Role;
import stripesbook.model.User;

public class SecuredActionBean extends BaseActionBean {
    private static final String TEST = "/WEB-INF/jsp/securetest.jsp";
    private static final String VIEW = "/WEB-INF/jsp/secured.jsp";

    private String role;
    public String getRole() { return role; }
    public void setRole(String role) {
        this.role = role;
        if (role != null) {
            User user = new User();
            user.getRoles().add(new Role(role));
            getContext().setUser(user);
        }
    }

    @DefaultHandler
    public Resolution test() {
        return new ForwardResolution(TEST);
    }
    @PermitAll
    public Resolution view1() {
        return new ForwardResolution(VIEW);
    }
    @RolesAllowed("Administrator")
    public Resolution view2() {
        return new ForwardResolution(VIEW);
    }
    public Resolution view3() {
        return new ForwardResolution(VIEW);
    }
    @DenyAll
    public Resolution deny() {
        return new ForwardResolution(VIEW);
    }
}
