/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.nonext;

import java.lang.reflect.Method;
import java.util.Collection;
import net.sourceforge.stripes.action.ActionBean;
import org.stripesstuff.plugin.security.InstanceBasedSecurityManager;
import stripesbook.action.BaseActionBean;
import stripesbook.ext.MyActionBeanContext;
import stripesbook.model.Role;
import stripesbook.model.User;

public class MySecurityManager extends InstanceBasedSecurityManager {
    @Override
    protected Boolean isUserAuthenticated(ActionBean bean, Method handler) {
        return ((BaseActionBean) bean).getContext().getUser() != null;
    }
    @Override
    protected Boolean hasRoleName(ActionBean bean, Method handler,
        String role)
    {
        MyActionBeanContext context =
            ((BaseActionBean) bean).getContext();

        User user = context.getUser();
        if (user != null) {
            Collection<Role> roles = user.getRoles();
            return roles != null && roles.contains(new Role(role));
        }
        return false;
    }
}
